#! /usr/bin/env python

from MMTK import *
from MMTK.Database import BlueprintHook
from MMTK import Hooks
from MMTK.Joiner import Joiner
from MMTK.Trajectory import StandardLogOutput
from MMTK.ForceFields import GenericForceField

ff = GenericForceField('mm3')
#ff = AmberForceField()
world = InfiniteUniverse(ff)
layer = Group('kaehler_a_layer')
join = Joiner(layer)
join.joinGroups(layer.hookup, layer.hookdown)
join.joinGroups(join.getIntermediateResult().hookup, layer.hookdown)
join.joinGroups(join.getIntermediateResult().hookup, layer.hookdown)
join.joinGroups(join.getIntermediateResult().hookup, layer.hookdown)
result = join.getResult()
result.setPositions(ff)
result.hydrogenateDanglingBonds(ff)

world.group = result
#minimizer = ConjugateGradientMinimizer(world, actions=[StandardLogOutput(50)])
#minimizer(convergence = 1.e-3, steps = 10)

from MMTK.ConfigIO import OutputFile
fmt = OutputFile('resultk.pdb', 'pdb_connect')
fmt.write(result)
fmt.close()

if 1:
    from MMTK import RasMol
    ras_session = RasMol.RasMol(result, 1)
    ras_session.RefreshScreen()
    ras_session.Interact()
