# Compile the MMTK extension modules and copy them to their destination
# directory.

import os, string, sys
import Scientific.Installation

lib = os.path.join(os.path.join(sys.exec_prefix, 'lib'),
                   'python'+sys.version[:3])

if os.path.exists('version_info'):
    info = open('version_info').readlines()
    platform = string.strip(info[0])
    version = string.strip(info[1])
    if sys.platform != platform or sys.version != version:
        os.system('make distclean')
        for file in ['Makefile.pre.in', 'Makefile.pre', 'Makefile', 'Setup']:
            if os.path.exists(file):
                os.unlink(file)

open('version_info', 'w').write(sys.platform+'\n' + sys.version+'\n')

if not os.path.exists('Makefile.pre.in'):
    source = os.path.join(os.path.join(lib, 'config'), 'Makefile.pre.in')
    if os.path.exists(source):
        os.system('cp ' + source + ' .')
    else:
        print "Copy Misc/Makefile.pre.in from the Python distribution"
        print "to this directory and try again."

if not os.path.exists('Setup'):
    os.system("sed -e s+@SCIENTIFIC@+" + Scientific.Installation.include_path +
              "+g < Setup.template > Setup")

if not os.path.exists('Makefile'):
    os.system("make -f Makefile.pre.in boot")

os.system("make")

os.system("grep '^SO' Makefile > temp")
line = open("temp").readlines()[0]
os.unlink("temp")
extension = string.strip(line[string.find(line, '=')+1:])

modules = ["MMTK_DCDmodule", "MMTK_minimizationmodule", "MMTK_dynamicsmodule",
	   "MMTK_trajectorymodule", "MMTK_forcefieldmodule",
           "MMTK_universemodule", "MMTK_deformationmodule"]
try:
    from lapack_dsy import dsyev
except ImportError:
    modules.append("lapack_dsyevmodule")

module_directory = os.path.join('..', os.path.join('MMTK', sys.platform))
os.system("mkdir -p " + module_directory)
for module in modules:
    module = module + extension
    destination = os.path.join(module_directory, module)
    os.system("rm -f " + destination)
    os.system("cp " + module + " " + destination)
