for (k = 0; k < nblist->npairs; k++, pair++) {
  if (cutoff_sq == 0. || pair->r_sq <= cutoff_sq) {
    int type1 = lj_type[pair->i1];
    int type2 = lj_type[pair->i2];
    if (type1 >= 0 && type2 >= 0) {
      double eps = eps_sigma[2*(ntypes*type1+type2)];
      double sigma = eps_sigma[2*(ntypes*type1+type2)+1];
      double r_sq = pair->r_sq;
      double sr2 = sqr(sigma)/r_sq;
      double sr6 = cube(sr2);
      double sr12 = sqr(sr6);
      int i = pair->i1;
      int j = pair->i2;
      vector3 rij;
      distance_vector_function(rij, x[j], x[i], distance_data);
      if (pair->one_four)
        eps *= one_four_factor;
      self->energy += 4.*eps*(sr12-sr6);
      self->virial += 24.*eps*(2.*sr12-sr6);
      if (gradients != NULL || force_constants != NULL) {
        double deriv = -24.*eps*(2.*sr12-sr6)/r_sq;
        if (gradients != NULL) {
          vector3 grad;
          grad[0] = deriv*rij[0];
          grad[1] = deriv*rij[1];
          grad[2] = deriv*rij[2];
          if (gradient_fn != NULL) {
            (*gradient_fn)(self, gradients, i, grad);
            vector_changesign(grad);
            (*gradient_fn)(self, gradients, j, grad);
          }
          else {
            vector3 *f = (vector3 *)((PyArrayObject *)gradients)->data;
            f[i][0] += grad[0];
            f[i][1] += grad[1];
            f[i][2] += grad[2];
            f[j][0] -= grad[0];
            f[j][1] -= grad[1];
            f[j][2] -= grad[2];
          }
        }
        if (force_constants != NULL) {
          double deriv2 = 24.*eps*(26.*sr12-7.*sr6)/r_sq;
          add_pair_fc(self, force_constants, fc_fn, i, j,
                      rij, r_sq, deriv, deriv2);
        }
      }
    }
  }
}
