for (k = 0; k < nblist->npairs; k++, pair++) {
  if (cutoff_sq == 0. || pair->r_sq <= cutoff_sq) {
    int i = pair->i1;
    int j = pair->i2;
    double qiqj = charge[i]*charge[j]*electrostatic_energy_factor;
    double r_sq = pair->r_sq;
    double r = sqrt(r_sq);
    vector3 rij;
    distance_vector_function(rij, x[j], x[i], distance_data);
    if (pair->one_four)
      qiqj *= one_four_factor;
    self->energy += qiqj/r;
    self->virial += qiqj/r;
    if (gradients != NULL || force_constants != NULL) {
      double deriv = -qiqj/(r*r_sq);
      if (gradients != NULL) {
        vector3 grad;
        grad[0] = deriv*rij[0];
        grad[1] = deriv*rij[1];
        grad[2] = deriv*rij[2];
        if (gradient_fn != NULL) {
          (*gradient_fn)(self, gradients, i, grad);
          vector_changesign(grad);
          (*gradient_fn)(self, gradients, j, grad);
        }
        else {
          vector3 *f = (vector3 *)((PyArrayObject *)gradients)->data;
          f[i][0] += grad[0];
          f[i][1] += grad[1];
          f[i][2] += grad[2];
          f[j][0] -= grad[0];
          f[j][1] -= grad[1];
          f[j][2] -= grad[2];
        }
      }
      if (force_constants != NULL) {
        double deriv2 = 2.*qiqj/(r*r_sq);
        add_pair_fc(self, force_constants, fc_fn, i, j,
                    rij, r_sq, deriv, deriv2);
      }
    }
  }
}
