# This module implements a function that finds atoms close enough that they
# should be considered bonded
#
# Written by Peter McCluskey (pcm@rahul.net)
#

from DelaunayTriangulation import DelaunayTriangulation
from Bonds import Bond

def deduceBonds(atomlist, forcefield):
    bonds = []
    dt = DelaunayTriangulation(atomlist, qhull = 1)
    pair_list = dt.listPositionsCloserThan(0.25)
    for t in pair_list:
	dist = (t[0].position() - t[1].position()).length()
	if dist < 0.2:
	    length = 0.2   # temp hack, can't use ff until atom types known
	    if t[0].symbol == 'H' and t[1].symbol == 'H':
		length = 0.15
	    #length = forcefield.defaultBondLength(tmpBond(t[0], t[1]), None)
	    if dist < length: 
		bonds.append(Bond((t[0], t[1])))
    return bonds

class tmpBond:
    def __init__(self, a1, a2):
	self.a1 = a1
	self.a2 = a2
	self.order = 1
